C
C
      SUBROUTINE POABRT
C**********************************************************************
C
C     abort of MC event generation due to fatal error:
C     print all information of event generation and history
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER ( ZERO = 0.D0 )
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C
      PARAMETER (MSTR=100)
      COMMON /STRING/ GAMBET(4,MSTR),NPOS(3,MSTR),NCODE(MSTR),
     &     IPAR1(MSTR),IPAR2(MSTR),IPAR3(MSTR),IPAR4(MSTR),
     &     NNCH(MSTR),IBHAD(MSTR),ISTR
C
      COMMON /ABRHRD/ XH1(50),XH2(50),IJHI1(50),IJHI2(50),
     &                IJHF1(50),IJHF2(50),PHARD1(4,50),PHARD2(4,50),IPTM
      COMMON /ABRSOF/ XS1(50),XS2(50),IJSI1(50),IJSI2(50),
     &                PSOFT1(4,50),PSOFT2(4,50)
C
      PARAMETER ( MSCAHD = 50 )
      COMMON /HARSLT/ LSCAHD,LSC1HD,
     &                ETAHD(MSCAHD,2) ,PTHD(MSCAHD), Q2SCA(MSCAHD,2),
     &                XHD(MSCAHD,2)   ,VHD(MSCAHD) ,X0HD(MSCAHD,2),
     &                NINHD(MSCAHD,2) ,NOUTHD(MSCAHD,2),
     &                N0INHD(MSCAHD,2),NBRAHD(MSCAHD,2),NPROHD(MSCAHD)
C
      WRITE(6,'(/,/,1X,A,/,1X,A)') 'POABRT: STOP OF PROGRAM EXECUTION',
     &                             '================================='
      WRITE(6,'(/,1X,A,/,1X,A)') 'LISTING OF AVAILABLE DATA FOLLOWS:'
C
      CALL SETMDL(0,0,-2)
      CALL POPREV(-1)
      CALL ACTPDF(0,ZERO,-2)
C  print selected parton flavours
      WRITE(6,'(1X,A,I4)') 'SELECTED SOFT FLAVOURS: ',KSOFT
      DO 700 I=1,KSOFT
        WRITE(6,'(10X,2I5)') IJSI1(I),IJSI2(I)
 700  CONTINUE
      WRITE(6,'(1X,A,I4)') 'SELECTED HARD FLAVOURS: ',KHARD
      DO 750 I=1,KHARD
        WRITE(6,'(10X,A,I5)') 'PROCESS:',NPROHD(I)
        WRITE(6,'(10X,A,2I5,7X,A,2I5)') 'INITIAL:',IJHI1(I),IJHI2(I),
     &                                  'FINAL:',IJHF1(I),IJHF2(I)
 750  CONTINUE
C  print selected parton momenta
      WRITE(6,'(1X,A,I4)') 'SELECTED SOFT MOMENTA: ',KSOFT
      DO 300 I=1,KSOFT
        WRITE(6,'(10X,A,4E12.3)') 'PAR.1',(PSOFT1(II,I),II=1,4)
        WRITE(6,'(10X,A,4E12.3)') 'PAR.2',(PSOFT2(II,I),II=1,4)
 300  CONTINUE
      WRITE(6,'(1X,A,I4)') 'SELECTED HARD MOMENTA: ',KHARD
      DO 350 I=1,KHARD
        WRITE(6,'(10X,A,4E12.3)') 'PAR.1',(PHARD1(II,I),II=1,4)
        WRITE(6,'(10X,A,4E12.3)') 'PAR.2',(PHARD2(II,I),II=1,4)
 350  CONTINUE
C  print COMMON HEPEVS
      CALL POPREV(0)
C  fragmentation process
      IF(ISTR.GT.0) THEN
C  print COMMON STRING
        CALL POPRST
        IF(ISWMDL(6).GE.0) CALL LULIST(1)
      ENDIF
C  last message
      WRITE(6,'(//10X,A,//1X,A)')
     &  'POABRT:WARNING: EXECUTION TERMINATED DUE TO FATAL ERROR',
     &'*** SIMULATING DIVISION BY ZERO TO GET TRACEBACK INFROMATION ***'
      ISTR = 100/IPAMDL(100)
      END
