C
C
      SUBROUTINE POFRIN
C********************************************************************
C
C     initialization of fragmentation packages BAMJET and DECAY
C     or JETSET 7.3
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
C  write block datas
*     CALL PRIBLO(0)
C  read file bblo.txt
*     CALL PRIBLO(1)
C
C  check particle codes and tables
      IF(IDEB(10).GE.15) CALL PCODES
C  write all data tables and decay modes
      IF(IDEB(10).GE.25) CALL DATESS
C
C  LUND JETSET 7.3 fragmentation
      CALL POLUIN(ISWMDL(6))
C  write parameter settings
      IF(IDEB(10).GE.5) CALL LULIST(13)
C  write all data tables and decay modes
      IF(IDEB(10).GE.25) CALL LULIST(12)
      END
