CDECK  ID>, HWUMPP.
*CMZ :-        -26/11/00  17.21.55  by  Bryan Webber
*-- Author :  Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWUMPP(M,GPM,PERM,U,UU,LR)
C-----------------------------------------------------------------------
C     APPLIES OPERATOR FROM HWUMPO ON SPINORS.
C     SPINOR COMPONENTS CAN BE PERMUTATED (PERM) AND TRANSVERSED (LR)
C-----------------------------------------------------------------------
      DOUBLE COMPLEX U(4), TEMP, A(4,4), M(16), UU(4), CZERO
      DOUBLE PRECISION GPM(2), FAC, ZERO, ONE, MONE
      INTEGER LR,TV(4,4,2),I,J, PERM(4), IZERO, GTOF(4)
      PARAMETER (ZERO=0.D0,CZERO=(0.D0,0.D0),IZERO=0)
      PARAMETER (ONE =1.D0,MONE = -1.D0)
      DATA GTOF/1,1,2,2/
      DATA TV/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,
     &        1,5,9,13,2,6,10,14,3,7,11,15,4,8,12,16/
      SAVE GTOF
      DO I=1,4
       FAC = GPM(GTOF(I))
       IF ((PERM(I).EQ.IZERO).OR.(FAC.EQ.ZERO)) THEN
        DO J=1,4
         A(I,J)=CZERO
        END DO
       ELSE
        IF(FAC.EQ.ONE) THEN
         TEMP = U(PERM(I))
        ELSEIF(FAC.EQ.MONE) THEN
         TEMP = -U(PERM(I))
        ELSE
         TEMP = FAC*U(PERM(I))
        ENDIF
        IF(TEMP.NE.ZERO) THEN
         DO J=1,4
          IF(M(TV(I,J,LR)).NE.ZERO) THEN
           A(I,J)=TEMP*M(TV(I,J,LR))
          ELSE
           A(I,J)=ZERO
          ENDIF
         END DO
        ELSE
         DO J=1,4
          A(I,J)=ZERO
         END DO
        END IF
       END IF
      END DO
      DO J=1,4
       UU(J)=A(1,J)+A(2,J)+A(3,J)+A(4,J)
      END DO
      RETURN
      END
