C
C
       DOUBLE PRECISION FUNCTION PLBEI0(X)
C**********************************************************************
C
C      Bessel Function I0
C
C**********************************************************************
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
       AX = ABS(X)
       IF (AX .LT. 3.75D0) THEN
         Y = (X/3.75D0)**2
         PLBEI0 =
     &     1.0D0+Y*(3.5156229D0+Y*(3.0899424D0+Y*(1.2067492D0
     &     +Y*(0.2659732D0+Y*(0.360768D-1+Y*0.45813D-2)))))
       ELSE
         Y = 3.75D0/AX
         PLBEI0 =
     &     (EXP(AX)/SQRT(AX))*(0.39894228D0+Y*(0.1328592D-1
     &     +Y*(0.225319D-2+Y*(-0.157565D-2+Y*(0.916281D-2
     &     +Y*(-0.2057706D-1+Y*(0.2635537D-1+Y*(-0.1647633D-1
     &     +Y*0.392377D-2))))))))
       ENDIF
       END
