C this is replacement of steer subroutine for RAPGAP  
C to include local settings from RunMC
 
      SUBROUTINE RUNMCrapgapsteer


      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"

      Integer nloop,nmax
      Parameter (nmax=100)
      character *4   para
      Real Rval
      Integer Ival,Ld,Le
      Common/steering/Nloop,Ld(nmax),Le(nmax),Ival(nmax),
     &  para(nmax),Rval(nmax)
      Integer Nevent
      Common/steer1/Nevent
      character *132 filnam
      Integer lunhbk
      Common/steer2/lunhbk,filnam
      LOGICAL         HBKOUT
      COMMON /QHBKLO/ HBKOUT



        write(6,*) 
     + "RUNMC: simulation of the steering subroutine in RAPGAP"  
        write(6,*)
     + "RUNMC: RUNMC GUI will change your steering values"
        write(6,*)
     + "RUNMC: this may give inconsistent steering values"
        write(6,*)
     + "RUNMC: better use the steering card:  rapgap3.cards !"

C set to large number - controlled by RunMC
       Nevent=100000000; 

C number of settings in pseudocar
       Nloop=14 

       do i=1,Nloop
       Ival(i) = -9999
       Rval(i) = -9999.
       Ld(i)=1
       Le(i)=0
       enddo 


C set energies and ID 
      if( abs(PID1).le.17) then
           para(1)='PLEP'
           Rval(1)=ENER1
                para(3)='LEPI'
                Ival(3)=PID1
       endif
      if( abs(PID1).ge.2000) then
           para(1)='PPIN'
           Rval(1)=ENER1
                para(3)='HADI'
                Ival(3)=PID1
       endif
      if( abs(PID2).lt.17) then
           para(2)='PLEP'
           Rval(2)=-1*ENER2
               para(4)='LEPI'
               Ival(4)=PID2
       endif
       if( abs(PID2).ge.2000) then
           para(2)='PPIN'
           Rval(2)=-1*ENER2
               para(4)='HADI'
               Ival(4)=PID2
        endif

* min Q2
       para(5)='QMIN' 
       Rval(5)=rQ2(2)   
** max Q2
       para(6)='QMAX'
       Rval(6)=rQ2(3)

* min Y 
       para(7)='YMIN'
       Rval(7)=rYbj(2) 
** max Y 
       para(8)='YMAX'
       Rval(8)=rYbj(3) 

** Xbj not set
*      CKIN(65)=rXbj(2) 
*      CKIN(66)=rXbj(3)  
*   find out - is this DIS mode ?

        iEP=0
        if( (abs(PID1).le.17) .and. (abs(PID2).gt.2000) ) iEP=1
        if( (abs(PID2).le.17) .and. (abs(PID1).gt.2000) ) iEP=1

** normal DIS  
        if (iEP.eq.1) then
          para(9)='IDIR'
          Ival(9)=1
        endif 

* set PDF for first particle
      para(10)='INPR'
      Ival(10)=1000000+1000*4+46
         IF (PDF1.eq.2.or.PDF2.eq.2) THEN
         Ival(10)=1000000+1000*3+72
         ELSEIF (PDF1.eq.3.or.PDF2.eq.3) THEN
         Ival(10)=1000000+1000*5+12
         ENDIF 

       if (iEP.eq.1) then
          para(11)='IPRO'
          Ival(11)=12
        
          para(12)='IDIF'
          Ival(12)=0

          para(13)='IFUL'
          Ival(13)=0

          para(14)='IGRI'
          Ival(14)=1
        endif





       END
