Summary: Split FORTRAN subroutines into separate files
Name: fsplit
Version: 5.5
Release: 1
Group: Development/Tools
Copyright: BSD
Packager: Morten Kjeldgaard <mok@imsb.au.dk>
Source: fsplit-5.5.tar.gz
BuildRoot: /var/tmp/fsplit
Prefix: /usr

%description 
Split single file containing source for several fortran programs
and/or subprograms into files each containing one subprogram unit.
Each separate file will be named using the corresponding subroutine,
function, block data or program name if one is found; otherwise the
name will be of the form mainNNN.f or blkdtaNNN.f . If a file of that
name exists, it is saved in a name of the form zzz000.f.  If -e option
is used, then only those subprograms named in the -e option are split
off; e.g.: fsplit -esub1 -e sub2 prog.f isolates sub1 and sub2 in
sub1.f and sub2.f. The space after -e is optional.

%prep
%setup
%build
cc -o fsplit fsplit.c 
%install
install -d $RPM_BUILD_ROOT/usr/bin
install -d $RPM_BUILD_ROOT/usr/man/man1
install -s -m 755 fsplit $RPM_BUILD_ROOT/usr/bin 
install -m 644 fsplit.1 $RPM_BUILD_ROOT/usr/man/man1/
%clean
rm -rf $RPM_BUILD_ROOT
%files
/usr/bin/fsplit
/usr/man/man1/fsplit.1
